-- A very compact implementation of a
-- fractal flame, aka electric sheep. 
-- It works by passing a random point
-- repeatedly through a system of 2 
-- (almost) linear transformations 
-- (aka an iterated function system), 
-- increasing the value at each pixel 
-- whenever the point being iterated 
-- passes through it.

-- by Algorias/Horology 
-- for Lovebyte 2023


x=2
y=2
t=2
function TIC()
 for j=-2,222 do
 for i=-2,222 do 
	
  -- (almost) linear fractal flame
  R=math.random(2)
  y=(t*x/R-y+x+222)*R/2 % 222
  x=(t*y/R-x+y+222)*R/2 % 222

  -- probabilistically count log(hits)
  pix(x,y,2^-pix(x,y)+pix(x,y)+math.random())

  -- probabilistically decay color
  pix(i,j,pix(i,j)+math.random()-.2)

  end end
 t=t-2/22^2 -- update time
end
